#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <sched.h>
#include <assert.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>

#include "vserver.h"
#include "namespace.h"

int main(int argc, char **argv)
{
	int xid, fd;
	char *cmd;

	if (argc < 4)
	{
		fprintf(stderr, "Usage: %s <xid> <source> <target>\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	xid = atoi(argv[1]);

	fd = open(argv[2], O_RDONLY | O_DIRECTORY);
	assert(fd == 3);

	vserver(VCMD_enter_namespace, xid, 0);

	fchdir(fd);

	cmd = (char*)malloc(sizeof(char)*15 + strlen(argv[3]) + 1);

	strcpy(cmd, "mount --bind . ");
	strcat(cmd, argv[3]);

	return system(cmd);
}
